
# as21  assember for S2    28 March 2020
# version 1.0

# type op ={1,2,3,4,5} label = 10
symtab = {                  # [type,value]
    'ld': [1,1],
    'st': [1,3],
    'mov': [5,5],
    'jmp': [5,6],
    'jal': [3,7],
    'jt': [3,8],
    'jf': [3,9],
    'add': [2,0],
    'sub': [2,1],
    'mul': [2,2],
    'div': [2,3],
    'and': [2,4],
    'or': [2,5],
    'xor': [2,6],
    'eq': [2,7],
    'ne': [2,8],
    'lt': [2,9],       
    'le': [2,10],
    'gt': [2,11],
    'ge': [2,12],
    'shl': [2,13],
    'shr': [2,14],
    'mod': [2,15],
    'ret': [5,19],
    'trap': [5,20],
    'push': [4,21],
    'pop': [4,22],
    'not': [4,23],
    }

def isnumeric(w):
    flag = True
    for c in w:
        if( not c.isdigit()):
            flag = False
    return flag

def isreg(w):
    return w[0] == 'r' and int(w[1:])  in range(0,32)

def isimm(w):
    return w[0] == '#'


# read input file and recognise three sections
def pass1():
    global fin
    mode = '*'
    linenum = 0
    ip = 0
    for line in fin:
        linenum += 1
#        print(line,end="")
        tok = line.strip().split()
        if( len(tok) < 1):
            continue
        cmd = tok[0]
        if( cmd == ";"):         # comment line
            continue
        if( cmd == ".code"):
            mode = 'C'
            continue
 #       elif( cmd == ".symbol"):
 #           mode = 'S'
 #           continue
        elif( cmd == ".data"):
            mode = 'D'
            continue
        elif( cmd[0] == ":" ):
             # dolabel
            symtab[cmd] = [10,ip]
            continue
        elif( cmd == ".end"):
            break
        
#        if( mode == "S"):
#            print("symbol:",tok)
        if( mode == "C"):
            ip += 1


def getV(w):
    return int(w[1:])

def getAds(w):
    if( isnumeric(w)):
        return int(w)
    else:               # search symtab for label
        return symtab[':'+w][1]

def str2(n):        # convert to string pad with blank
    return str(n) + " "

def outL(op,a1,a2):
    s = str2(op)+str2(a1)+str2(a2)
    fout.write('L '+ s + '\n')
    
def outD(op,a1,a2,d):
    s = str2(op)+str2(a1)+str2(a2)+str2(d)
    fout.write('D '+ s + '\n')
    
def outX(op,a1,a2,a3):
    s = str2(a1)+str2(a2)+str2(a3)+str2(op)
    fout.write('X 31 '+ s + '\n')
    
def dogroup1(op,tok):       # ld/st abs,idx,disp
    a2 = tok[2]
    if( a2[0]  == '+'):
        outX(17,getV(tok[1]),getV(a2[1:]),getV(tok[3]))
    elif( a2[0] == '@'):
        outD(op+1,getV(tok[1]),getV(tok[3]),int(a2[1:]))
    else:
        outL(op,getV(tok[1]),int(tok[2]))
    
def dogroup2(op,tok):       #  op r r r, op r r i, add/sub...
    if( isreg(tok[3])):
        outX(op,getV(tok[1]),getV(tok[2]),getV(tok[3]))
    elif( isimm(tok[3])):
        outD(op+10,getV(tok[1]),getV(tok[2]),getV(tok[3]))
 
def dogroup3(op,tok):       # jt/jf/jal r ads
    outL(op,getV(tok[1]),getAds(tok[2]))
    
def dogroup4(op,tok):       # op r1 r2, push/pop/not
    if( isreg(tok[1]) and isreg(tok[2])):
        outX(op,getV(tok[1]),getV(tok[2]),0)

def pass2():
    global fin
    mode = '*'
    linenum = 0
    for line in fin:
        linenum += 1
        print(linenum,line,end="")
        tok = line.strip().split()
        if( len(tok) < 1):
            continue
        cmd = tok[0]
        if( cmd == ";"):         # comment line
            continue
        if( cmd == ".code"):
            mode = 'C'
            continue
#        elif( cmd == ".symbol"):
#            mode = 'S'
#            continue
        elif( cmd == ".data"):
            mode = 'D'
            fout.write('a ' + tok[1] + '\n')
            continue
        elif( cmd[0] == ":" ):
             # dolabel
            continue
        elif( cmd == ".end"):
            break
        
        if( mode == "C"):
#            print("code:",tok)
            op = tok[0]
            optype = symtab[op][0]
            opcode = symtab[op][1]
            if( optype == 1):           # group 1-4
                dogroup1(opcode,tok)
            elif( optype == 2):
                dogroup2(opcode,tok)
            elif( optype == 3):
                dogroup3(opcode,tok)
            elif( optype == 4):
                dogroup4(opcode,tok)
            else:                       # group 5
                if( op == 'mov'):
                    if( isreg(tok[1]) and isreg(tok[2])):
                        outX(16,getV(tok[1]),getV(tok[2]),0)
                    elif( isreg(tok[1]) and isimm(tok[2])):
                        outL(5,getV(tok[1]),getV(tok[2]))
                elif( op == 'jmp'):
                    outL(opcode,0,getAds(tok[1]))
                elif( op == 'trap'):
                    outX(opcode,getV(tok[1]),getV(tok[2]),0)
                elif( op == 'ret'):
                    outX(opcode,getV(tok[1]),0,0)
                
        elif( mode == "D"):
#            print("data:",tok)
            for x in tok:
                if( x == ';'):
                    break
                fout.write('w ' + x +'\n')


def dumplabel():
    for x in symtab.values():
        if( x[0] == 10):
            print(x)
  
def makename(name):
    i = name.index('.')
    return name[:i]
         
def main():
    global fin,fout
    
    fname = input("input:").strip()
    foname = makename(fname) + '.obj'
    fin = open(fname,"r")
    pass1()
    fin.seek(0)    # rewind
#  print(symtab)
    print("start pass 2")
    fout = open(foname,'w')
    fout.write('a 0\n')
    pass2()
    fout.write('e\n')
    fout.close()
    fin.close()
#    dumplabel()

main()
